#include<iostream>
#include<cmath>
using namespace std;

inline int sp(int x1, int y1, int x2, int y2) { return x1*x2+y1*y2; }
inline int vp(int x1, int y1, int x2, int y2) { return x1*y2-y1*x2; }

int on(int x1, int y1, int x2, int y2, int x, int y)
{
    int os=vp(x2-x1, y2-y1, x-x1, y-y1);
    if(os) return 0;
    return sp(x2-x1, y2-y1, x-x1, y-y1) * sp(x1-x2, y1-y2, x-x2, y-y2) >=0;
}

int in(int x1, int y1, int x2, int y2, int x3, int y3, int x, int y)
{
    int t1=vp(x1, y1, x, y),
        t2=vp(x2-x1, y2-y1, x-x1, y-y1),
        t3=vp(x3-x2, y3-y2, x-x2, y-y2),
        t4=vp(-x3, -y3, x-x3, y-y3);
    return ( t1>0 && t2>0 && t3>0 && t4>0 ) ||
           ( t1<0 && t2<0 && t3<0 && t4<0 ) ||
           on( 0,  0, x1, y1, x, y) ||
           on(x1, y1, x2, y2, x, y) ||
           on(x2, y2, x3, y3, x, y) ||
           on(x3, y3,  0,  0, x, y);
}

int main()
{
    int x1, y1, x2, y2, x3, y3, px, py, br=0;
    cin>>x1>>y1>>x2>>y2;
    
    if(sp(x1, y1, x2, y2)==0)
    {
        x3=x2; y3=y2;
        x2=x1+x3;
        y2=y1+y3;
    }
    else
    {
        if(sp(x1, y1, x2-x1, y2-y1)==0)
        {
            x3=x2-x1;
            y3=y2-y1;
        }
        else
        {
            swap(x1, x2); swap(y1, y2);
            x3=x2-x1;
            y3=y2-y1;
        }
    }
    
    int n;
    cin>>n;
    
    int i;
    for(i=0; i<n; i++) 
    {
        scanf("%d%d", &px, &py);
        if(in(x1, y1, x2, y2, x3, y3, px, py)) br++;
    }
    
    printf("%d\n", br);
    return 0;
}
