#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;

int n, xa, xb,xc , ya, yb, yc, sol , x, y;

double dist (int x1,int y1, int x2, int y2)
{
 return sqrt( (x1 - x2)*(x1 - x2) + (y1 - y2) * (y1 - y2) );       
}

double scalar_product (int xa,int ya,int xb,int yb)
{
 return xa * xb + ya * yb; 
}

int main()
{ x=0; y=0;
 //printf ("%lf", scalar_product ());   
 scanf ("%d%d%d%d%d", &xa, &ya, &xb, &yb, &n);
 
 if (scalar_product (xa, ya, xb, yb) == 0)
  {
   xc = xa + xb ;
   yc = ya + yb ;                  
  }
 else 
  {
   if (dist (0,0 , xa,ya) < dist (0,0 , xb,yb))
    {
     xc = xb - xa ;
     yc = yb - ya ;
     swap ( xc , xb );
     swap ( yc , yb );
    }
   else 
    {
     xc = xa - xb ;
     yc = ya - yb ;   
     swap ( xc , xa );
     swap ( yc , ya );
    } 
  }
 
 for (int i=0 ; i < n;i ++)
  {
   int t, t1;
   scanf ("%d%d", &t, &t1);
   if ( scalar_product ( xa, ya, t , t1 ) >= 0 &&                // OA . Ot
        scalar_product ( -xa, -ya, t - xa , t1 - ya ) >= 0 &&    // AO . At
        scalar_product ( xb, yb, t , t1 ) >= 0 &&                // OB . Ot
        scalar_product ( -xb, -yb, t - xb , t1 - yb ) >= 0 &&    // BO . Bt
        
        scalar_product ( xc - xa, yc - ya, t - xa , t1 - ya ) >= 0 &&      // AC . At
        scalar_product ( xa - xc, ya - yc, t - xc , t1 - yc ) >= 0 &&      // CA . Ct
        scalar_product ( xc - xb, yc - yb, t - xb , t1 - yb ) >= 0 &&      // BC . Bt
        scalar_product ( xb - xc, yb - yc, t - xc , t1 - yc ) >= 0         // CB . Ct
      ) sol ++ ;
  }
 printf ("%d\n", sol); 
 return 0;    
}
